(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["ReduxWebmidi"] = factory();
	else
		root["ReduxWebmidi"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.l = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// identity function for calling harmory imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };

/******/ 	// define getter function for harmory exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		Object.defineProperty(exports, name, {
/******/ 			configurable: false,
/******/ 			enumerable: true,
/******/ 			get: getter
/******/ 		});
/******/ 	};

/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};

/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 3);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports) {

"use strict";
"use strict";
var midi = new Promise(function (res, rej) { return rej('Could not load WebMidi. WebMidi is only supported on Chrome as of now.'); });
if (navigator.requestMIDIAccess)
    midi = navigator.requestMIDIAccess();
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = midi;


/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

"use strict";
"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var utils_1 = __webpack_require__(2);
var initialState = {
    ports: []
};
var addPort = function (state, port) {
    var ports = state.ports.slice();
    if (ports[port.id])
        ports[port.id].type = 'input/output';
    else
        ports[port.id] = __assign({}, port, { keys: [] });
    return __assign({}, state, { ports: ports });
};
var removePort = function (state, port) {
    var ports = state.ports.slice();
    if (ports[port.id])
        if (ports[port.id].type === 'input/output')
            ports[port.id].type = 'input/output'.replace(new RegExp("/?" + port.type + "/?"), '');
        else
            ports = ports.filter(function (p) { return p.id !== port.id; });
    return __assign({}, state, { ports: ports });
};
var queueMessage = function (state, message) {
    var ports = state.ports.slice();
    var curId = message.currentTarget.id;
    var status = message.data[0];
    var curKey = message.data[1];
    var velocity = message.data[2];
    ports[curId].keys[curKey] = { status: status, velocity: velocity };
    return __assign({}, state, { ports: ports });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = utils_1.createReducer(initialState, {
    MIDI_CONNECTED: addPort,
    MIDI_DISCONNECTED: removePort,
    MIDI_MESSAGE: queueMessage
});


/***/ },
/* 2 */
/***/ function(module, exports) {

"use strict";
"use strict";
function createReducer(initialState, reducerMap) {
    return function (state, action) {
        if (state === void 0) { state = initialState; }
        var reducer = reducerMap[action.type];
        return reducer
            ? reducer(state, action.payload)
            : state;
    };
}
exports.createReducer = createReducer;


/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

"use strict";
"use strict";
var midi_1 = __webpack_require__(0);
exports.midiPromise = midi_1.default;
var reducer_1 = __webpack_require__(1);
exports.midiReducer = reducer_1.default;
var refreshPorts = function (store, access) {
    for (var _i = 0, _a = access.inputs; _i < _a.length; _i++) {
        var input = _a[_i];
        var curInput = input[1];
        var id = curInput.id, name_1 = curInput.name, manufacturer = curInput.manufacturer, state = curInput.state, type = curInput.type;
        store.dispatch({
            type: 'MIDI_CONNECTED',
            payload: {
                id: id,
                name: name_1,
                manufacturer: manufacturer,
                state: state,
                type: type
            }
        });
        curInput.onmidimessage = function (e) {
            store.dispatch({ type: 'MIDI_MESSAGE', payload: e });
        };
    }
    for (var _b = 0, _c = access.outputs; _b < _c.length; _b++) {
        var output = _c[_b];
        var curOutput = output[1];
        var id = curOutput.id, name_2 = curOutput.name, manufacturer = curOutput.manufacturer, state = curOutput.state, type = curOutput.type;
        store.dispatch({
            type: 'MIDI_CONNECTED',
            payload: {
                id: id,
                name: name_2,
                manufacturer: manufacturer,
                state: state,
                type: type
            }
        });
    }
};
var midiProvider = function (store) {
    midi_1.default.then(function (access) {
        refreshPorts(store, access);
        access.onstatechange = function (e) {
            var _a = e.port, id = _a.id, name = _a.name, manufacturer = _a.manufacturer, state = _a.state, type = _a.type;
            var copy = { id: id, name: name, manufacturer: manufacturer, state: state, type: type };
            if (copy.state === 'disconnected')
                store.dispatch({ type: 'MIDI_DISCONNECTED', payload: copy });
            if (copy.state === 'connected')
                store.dispatch({ type: 'MIDI_CONNECTED', payload: copy });
        };
    });
};
exports.midiProvider = midiProvider;


/***/ }
/******/ ]);
});